unit nasobenie;
interface

uses bigint;
const
  KAR_THR=22;
  SS_THR=13;
  SS_THR1=1380;

function multnaive(a,b:TBigInt):TBigInt;
procedure multnaive_(a,b:TBigInt; var c:TBigInt);
function karatsuba(a,b:TBigInt):TBigInt;
procedure karatsuba_(a,b:TBigInt; work:PDigits; var c:TBigInt);
function misto(k:longword):longword;
function multss(u,v:TBigInt):TBigInt;
procedure multss_(u,v,work:Pdigits; k:longword; c:Pdigits);

implementation

function multnaive(a,b:TBigInt):TBigInt;
begin
  getmem(result.digit,4*(a.len+b.len));
  multnaive_(a,b,result);
end;

procedure multnaive_(a,b:TBigInt; var c:TBigInt);
var i,j,z:integer;
    ta,tb,tc:longword;
begin
 if (a.sgn and b.sgn)=0 then begin c.sgn:=0; c.len:=0; exit; end;
 if a.sgn>0 then c.sgn:=b.sgn else c.sgn:=-b.sgn;
 c.len:=a.len+b.len;
 fillchar(c.digit^,4*a.len,0);
 for j:=0 to b.len-1 do begin
  tb:=b.digit[j];
  if tb=0 then c.digit[a.len+j]:=0 else
  begin
   z:=0;
   for i:=0 to a.len-1 do
   begin
    ta:=a.digit[i]; tc:=c.digit[i+j];
    asm
      mov eax,ta        //eax:=ta
      mul eax,tb        //eax:=ta*tb mod 2^32, edx:=ta*tb div 2^32
      add eax,z         //eax:=eax+z
      adc edx,0         //pripadny prenos do vyssej cifry v edx
      add eax,tc        //eax:=eax+tc
      adc edx,0         //pripadny prenos do vyssej cifry v edx
      mov tc,eax        //uloz vysledok tc:=ta*tb+z+tc mod 2^32
      mov z,edx         //uloz zbytok z:=ta*tb+z+tc div 2^32
    end;
    c.digit[i+j]:=tc;
   end;
   c.digit[j+a.len]:=z;
  end;
 end;
 if z=0 then dec(c.len);
end;

function karatsuba(a,b:TBigInt):TBigInt;
var n:integer;
    work:PDigits;
begin
 n:=a.len;
 if n<b.len then n:=b.len;
 if n<KAR_THR then result:=multnaive(a,b) else
 begin
   if (n and 1)>0 then inc(n);
   getmem(result.digit,4*(a.len+b.len));
   getmem(work,4*2*n+4*180);
   karatsuba_(a,b,work,result);
   if a.sgn>0 then result.sgn:=b.sgn else result.sgn:=-b.sgn;
   freemem(work);
 end;
end;

procedure karatsuba_(a,b:TBigInt; work:PDigits; var c:TBigInt);
var u0,v0,u1,v1,r1,r2,r:TBigInt;
    i,n:integer;
begin
  if b.len>a.len then begin u0:=a; a:=b; b:=u0; end;
  if b.sgn=0 then begin c.sgn:=0; c.len:=0; exit; end;
  if a.len<KAR_THR then begin multnaive_(a,b,c); exit; end;
  n:=(a.len+1) shr 1;
  u0.sgn:=1; u0.digit:=a.digit;
  i:=n-1; while (i>=0) and (u0.digit[i]=0) do dec(i);
  u0.len:=i+1; if u0.len=0 then u0.sgn:=0;
  u1.sgn:=1; u1.digit:=@a.digit[n]; u1.len:=a.len-n;
  if b.len>n then begin
    v0.sgn:=1; v0.digit:=b.digit;
    i:=n-1; while (i>=0) and (v0.digit[i]=0) do dec(i);
    v0.len:=i+1; if v0.len=0 then v0.sgn:=0;
    v1.sgn:=1; v1.digit:=@b.digit[n]; v1.len:=b.len-n;
  end else begin
    v0.sgn:=1; v0.digit:=b.digit; v0.len:=b.len;
    v1.sgn:=0; v1.len:=0;
  end;
  r1.digit:=work;
  r2.digit:=@work[n+1];
  i_sum(u0,u1,r1);
  i_sum(v0,v1,r2);
  r.digit:=@c.digit[n];
  karatsuba_(r1,r2,@work[2*n+2],r);
  karatsuba_(u0,v0,@work[2*n],r1);
  i:=r.len;
  if i<n then begin derase(@r.digit[i],n-i); i:=n; end;
  i_sub(r1,r);
  i_addspecr(n,r1,r);
  karatsuba_(u1,v1,@work[2*n],r1);
  i_sub(r1,r);
  i_addspecl(n,r1,r);
  if r.len>i then i:=r.len;
  if i<a.len+b.len-n then derase(@r.digit[i],a.len+b.len-n-i);
  c.len:=r.len+n;
  c.sgn:=1;
end;

function misto(k:longword):longword;
var b,l,lgb,lgl,o,p:longword;
begin
if k<7 then begin misto:=4; exit; end;
lgb:=k div 2;
lgl:=k-lgb;
b:=1 shl lgb;
l:=1 shl lgl;
o:=5*(b div 2)*((2*l) div 32 +1);
p:=2*b*((2*l) div 32 +1)+ misto(lgl+1);
if o>p then misto:=o else
misto:=p;
end;

function multss(u,v:TBigInt):TBigInt;
var l,lgb,lgl,lgn,k,kk:longword;
    n:integer;
    work,uu,vv:PDigits;
begin
  n:=u.len;
  if n<v.len then n:=v.len;
  if n<SS_THR1 then result:=karatsuba(u,v) else
  begin
   n:=u.len+v.len;
   asm
     mov eax,n
     dec eax
     xor ecx,ecx
@loop:
     inc ecx
     shr eax,1
     jnz @loop
     mov lgn,ecx
   end;  //lgn=ceil(log n)
   kk:=1 shl lgn;
   getmem(uu,4*(kk+1));
   getmem(vv,4*(kk+1));
   dmove(u.digit,uu,u.len);
   dmove(v.digit,vv,v.len);
   derase(@uu[u.len],kk+1-longword(u.len));
   derase(@vv[v.len],kk+1-longword(v.len));
   k:=lgn+5;
   lgb:=k div 2;
   lgl:=k-lgb;
   l:=1 shl lgl;
   getmem(result.digit,4*(kk+1));
   getmem(work,4*(5*(((2*l) div 32 +1) shl (lgb-1))));
   result.len:=kk;
   multss_(uu,vv,work,k,result.digit);
   if u.sgn>0 then result.sgn:=v.sgn else result.sgn:=-v.sgn;
   freemem(work);
   freemem(uu); freemem(vv);
  end;
end;

procedure multss_(u,v,work:Pdigits; k:longword; c:Pdigits);  //k>=5
var  um,vm,cm,ym,fm,gm:TBigInt;
     b,bb,l,ll,ll1,ll2,ll21:longword;
     u1,v1,x,y:Pdigits;
     i,j,n:longword;
     psi,omega:longword;
     h:word;
begin
  n:=1 shl (k-5);
  if u[n]=1 then
  begin
   mod_diff(v,c,n);
   exit;
  end;
  if v[n]=1 then
  begin
   mod_diff(u,c,n);
   exit;
  end;
  um.sgn:=1;
  vm.sgn:=1;
  if k<SS_THR then
  begin
   um.digit:=u;
   vm.digit:=v;
   um.len:=1 shl (k-5);
   vm.len:=um.len;
   cm.digit:=work;
   karatsuba_(um,vm,@cm.digit[2*um.len],cm);
   mod_mod(work,c,um.len);
  end else
  begin        //konstrukcia b, l
   b:=k div 2;
   l:=k-b;
   bb:=1 shl b;
   ll:=1 shl (l-5); ll1:=ll+1;
   ll2:=2*ll; ll21:=ll2+1;
   if k mod 2=0 then psi:=2 else psi:=4; // psi a omega podla tabulky
   omega:=2*psi;
   //w''_i
   u1:=u;    //u1 ukazuje na zaciatok u
   x:=work;  //x ukazuje na zaciatok pracovneho miesta
   j:=0;     //pocitadlo
   for i:=1 to bb do //\tilde u
   begin
    dmove(u1,@x[ll21],ll); //u_i kopirujem do pracovneho miesta na poziciu x+ll2+1
    derase(@x[ll21+ll],ll1); //pridam ll+1 nul
    shlmod(@x[ll21],x,j,ll2); //u_i nasobim psi na j-tu
    inc(j,psi); //zvacsim j
    inc(u1,ll); //ukazujem na u_(i+1)
    inc(x,ll21); //ukazujem na dalsiu poziciu \tilde u
   end;
   //x ukazuje na koniec \tilde u +1
   //u1 ukazuje na koniec u  +1
   v1:=x; //v1  ukazuje na koniec \tilde u +1
   u1:=v; //u1 ukazuje na zaciatok v
   j:=0;  //pocitadlo
   for i:=1 to bb do  //konstrukcia \tilde v
   begin
    dmove(u1,@x[ll21],ll); //v_i kopirujem do pracovneho miesta na poziciu ll2+1+"koniec \tilde u"
    derase(@x[ll21+ll],ll1); //pridam ll2+1 nul
    shlmod(@x[ll21],x,j,ll2); //v_i nasobim psi na j-tu
    inc(u1,ll); //zvacsim j
    inc(j,psi); //ukazujem na v_(i+1)
    inc(x,ll21);  //ukazujem na dalsiu poziciu \tilde v
   end;
   //x ukazuje na koniec \tilde v +1
   //u1 ukazuje na koniec v +1
   u1:=work; //u1 ukazuje na zaciatok pracovneho miesta na zaciatok \tilde u
   DFTmod(b,omega,ll2,ll21,u1,x);// DFT \tilde u
   DFTmod(b,omega,ll2,ll21,v1,x);// DFT \tilde v
   for i:=1 to bb do //nasobenie DFT \tilde u  a DFT \tilde u  po zlozkach
   begin
    multss_(u1,v1,x,l+1,v1);
    inc(u1,ll21);
    inc(v1,ll21);
   end;
   //u1 ukazuje na zaciatok r
   //v1 ukazuje za r
   iDFTmod(b,omega,ll2,u1,work); //iDFT nasobku DFT \tilde u a DFT \tilde u
   //u1 ukazuje na vysledok iDFT
   dmove(u1,work,ll21);
   j:=psi;
   x:=@work[ll21]; //x ukazuje na zaciatok pracovneho miesta
   inc(u1,ll21);
   for i:=2 to bb do //nasobim vektor \tilde c psi na minus j-tu
   begin
    shrmod(u1,x,j,ll2);
    inc(j,psi);
    inc(x,ll21);
    inc(u1,ll21);
   end;    //na w'' mi ukazuje work
    //x ukazuje na koniec c +1
    //u1 ukazuje na koniec \tilde c +1

   //w'_i
   ss_interlace(u,x,b,ll*4);//konstrukcia \hat u  ukazuje na neho x
   j:=b shl b; //b*bb
   j:=(j+j+j+31) div 32; //horna cela cast 3*b*bb/32
   v1:=@x[j]; //v1 ukazuje na koniec \hat u +1
   ss_interlace(v,v1,b,ll*4);  //konstrukcia \hat v  ukazuje na neho v1
   um.len:=j;
   vm.len:=j;
   um.digit:=x;
   vm.digit:=v1;
   cm.digit:=@v1[j];
   karatsuba_(um,vm,@cm.digit[2*j],cm); //nasobenie \hat u a \hat v pomocou karatsubu, vysledok v cm
   cm.digit[2*j]:=0;  //aby som mohla volat ss_extract
   ss_extract(cm.digit,x,b); // konstrukcia w'_i, na pole w'_i mi ukazuje x
     //work ukazuje na zaciatok pola w''_i
     //x ukazuje na zaciatok pola w'_i
   um.digit:=work;
   um.len:=ll21;
   y:=@x[bb div 2];//y ukazuje na volne miesto
   y[0]:=bb; // davam do y hodnotu bb*(2^ll2+1)
   derase(PDigits(longword(y)+4),ll2-1);
   y[ll2]:=bb;
   cm.digit:=work; cm.sgn:=1; //cm ukazuje na sucty kladnych w_i
   ym.digit:=@y[ll21]; ym.sgn:=1; //ym ukazuje na sucty zapornych w_i
   vm.digit:=@j; vm.len:=1;//vm ukazuje na j
   fm.sgn:=1; fm.len:=ll21; fm.digit:=y; //fm je obsah y
   h:=bb-1;
   j:=word(word(x[0])-word(um.digit[0])) and h; //(w'_i-w''_i) mod b
   i_add(vm,um);
   um.digit[ll2]:=um.digit[ll2]+j; //z_i=((w'_i-w''_i) mod b )*(2^{2l}+1)+w''_i
   if um.digit[ll2]>=1 then
   begin
    gm.digit:=um.digit; //ukazuje na z_i
    gm.sgn:=-1;  //dam tam minus
    gm.len:=ll21;
    i_add(fm,gm); //odpocitam z_i od b(2^2l+1)
    dmove(gm.digit,ym.digit,ll21);
    derase(@cm.digit[0],ll21);//posunutie v 2 poli
   end else derase(@ym.digit[0],ll21);//posunutie v druhom poli
   inc(um.digit,ll21); // posuniem ukazatel v poli w''_i
   inc(cm.digit,ll);
   inc(ym.digit,ll);
   x:=PDigits(longword(x)+2); //posuniem ukazatel v poli w'_i
   for i:=2 to bb do //konstrukcia z_i
   begin
    j:=word(word(x[0])-word(um.digit[0])) and h; //(w'_i-w''_i) mod b
    i_add(vm,um);
    um.digit[ll2]:=um.digit[ll2]+j; //z_i=((w'_i-w''_i) mod b )*(2^{2l}+1)+w''_i
    if um.digit[ll2]>=i then
    begin
     gm.digit:=um.digit; //ukazuje na z_i
     gm.sgn:=-1;  //dam tam minus
     gm.len:=ll21;
     i_add(fm,gm); //odpocitam z_i od b(2^2l+1)
     ym.len:=ll1; gm.len:=ll21;
     i_add(gm,ym); //pripocitaj w_i*2^il
     derase(@cm.digit[ll1],ll);//posunutie v 2 poli
    end else
    begin
     cm.len:=ll1;
     i_add(um,cm); //pripocitaj w_i
     derase(@ym.digit[ll1],ll);//posunutie v druhom poli
    end;
    inc(um.digit,ll21); // posuniem ukazatel v poli w''_i
    inc(cm.digit,ll);
    inc(ym.digit,ll);
    x:=PDigits(longword(x)+2); //posuniem ukazatel v poli w'_i
   end;
   um.digit:=@y[ll21];
   vm.digit:=work;
   um.len:=n+ll1;
   vm.len:=um.len;
   um.sgn:=-1;
   i_add(um,vm);
   if vm.sgn>=0 then mod_modp(vm.digit,c,n,ll1)
   else mod_modn(vm.digit,c,n,ll1);
  end;
end;

end.
