unit okienko;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, bigint, nasobenie;

const MAXNUM=4294967295;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit7: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function generuj(n:integer):TBigInt;
var i:integer;
begin
  getmem(result.digit,4*n);
  result.sgn:=1; result.len:=n;
  for i:=0 to n-1 do result.digit[i]:=random(MAXNUM);
  if result.digit[n-1]=0 then result.digit[n-1]:=1;
end;

procedure priprav(var u,v,c:TBigInt; var work:PDigits; var k:longword);
var l,lgb,lgl,lgn,kk:longword;
    n:integer;
begin
 n:=u.len;
 if v.len>n then n:=v.len;
 asm
   mov eax,n
   dec eax
   xor ecx,ecx
@loop:
   inc ecx
   shr eax,1
   jnz @loop
   inc ecx
   mov lgn,ecx
 end;  //lgn=ceil(log n)+1
 kk:=1 shl lgn;
 reallocmem(u.digit,4*(kk+1));
 reallocmem(v.digit,4*(kk+1));
 derase(@u.digit[u.len],kk+1-longword(u.len));
 derase(@v.digit[v.len],kk+1-longword(v.len));
 k:=lgn+5;
 lgb:=k div 2;
 lgl:=k-lgb;
 l:=1 shl lgl;
 getmem(c.digit,4*(kk+1));
 getmem(work,4*(5*(((2*l) div 32 +1) shl (lgb-1))));
 u.len:=kk+1;
 v.len:=kk+1;
 u.sgn:=1;
 v.sgn:=1;
 c.sgn:=1;
 c.len:=kk;
end;

procedure testuj(x,y:integer; var r1,r2:boolean; var t:string);
var c1,c2,c3,c4:TBigInt;
    w:PDigits;
    i:integer;
    t1,t2:int64;
    k,j:longword;
begin
  c1:=generuj(x);
  c2:=generuj(x);
  getmem(c3.digit,4*2*x);
  getmem(c4.digit,4*2*x);
  getmem(w,4*2*(x+1)+4*180);

  t1:=gettickcount;
  for i:=1 to y do multnaive_(c1,c2,c3);
  t2:=gettickcount;
  t:=t+'naive: '+inttostr(t2-t1);

  t1:=gettickcount;
  for i:=1 to y do karatsuba_(c1,c2,w,c4);
  t2:=gettickcount;
  t:=t+', Karatsuba: '+inttostr(t2-t1);
  i_sub(c3,c4);
//c4.sgn:=0;
  r1:=(c4.sgn=0);
  freemem(c4.digit);
  freemem(w);

  priprav(c1,c2,c4,w,k);
  //for j:=9 to 22 do begin
  // SS_THR1:=j;
   t1:=gettickcount;
   for i:=1 to y do multss_(c1.digit,c2.digit,w,k,c4.digit);
   t2:=gettickcount;
   t:=t+', SS: '+inttostr(t2-t1);
 // end;
  i_sub(c3,c4);
//c4.sgn:=0;
  r2:=(c4.sgn=0);
  freemem(w);
  freemem(c4.digit);
  freemem(c3.digit);
  freemem(c2.digit);
  freemem(c1.digit);
end;


procedure TForm1.Button1Click(Sender: TObject);
var i,j,x,y,od,doo,z,krok:integer;
    t1,t3,t4:int64;
    r1,r2:boolean;
    t:string;
    f:textfile;
begin
  assignfile(f,'data.txt');
  rewrite(f);
  od:=strtoint(Edit1.Text);
  doo:=strtoint(Edit2.Text);
  y:=strtoint(Edit5.Text);
  x:=strtoint(Edit6.Text);
  krok:=strtoint(Edit7.Text);
  for j:=1 to x do begin
    z:=od;
    while z<=doo do
    begin
     Edit3.Text:=inttostr(z); Edit3.Refresh;
     t:='';
     testuj(z,y,r1,r2,t);
     if r1 and r2 then Edit3.Text:='ok' else
     begin
       if (not r1) then Edit3.Text:='chyba1' else Edit3.Text:='chyba2';
       writeln(f,Edit3.Text);
       closefile(f);
       exit;
     end;
     Edit4.Text:=t;
     Edit4.Refresh;
     writeln(f,z,', ',y,', ',t);
     inc(z,krok);
    end;
  end;
 closefile(f);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
end;

end.
